export declare const VisionCore: {
    /**
   * Sets environment and initializes sdk.
   * @param {string} environment - environment.
   */
    setEnvironment: (environment: "staging" | "dev" | "sandbox" | "qa" | "production") => void;
    /**
   * Loads on-device models without requiring the camera view.
   * @param {string} token - Authentication token.
   * @param {string} apiKey - API Key.
   * @param {string} modelType - Model type ("shipping_label", "bill_of_lading", etc.).
   * @param {string} modelSize - Model size ("nano", "micro", "small", "medium", "large", "xlarge").
   */
    loadModel: (token: string | null, apiKey: string | null, modelType: string, modelSize: string) => Promise<void>;
    /**
    * Subscribes to model download progress updates.
    */
    onModelDownloadProgress: (callback: (progress: number, downloadStatus: boolean, isReady: boolean) => void) => import("react-native").EmitterSubscription;
};
//# sourceMappingURL=VisionCore.d.ts.map